#
# get player values from psychostats 2.2 mysql database
#


use strict;
use DBI;

#
# !!!
# YOU NEED TO EDIT THESE SIX VARIABLES TO MATCH YOUR ENVIRONMENT
# !!!
#
my $dbhost = "localhost"; 
my $dbname = "psychstats";
my $tablename = "pstats_plr";
my $dbuser = "psychouser";
my $dbpassword = "psychopassword";
my $player_values_file = "player_values.txt";

open FOUT, ">$player_values_file" or die "ERROR: file open failed for $player_values_file: $!\n";

my$db = DBI->connect("DBI:mysql:$dbname;host=$dbhost",
	$dbuser,
	$dbpassword,
	{ PrintError => 0, RaiseError => 0, AutoCommit => 1 }
) or die("MYSQL ERROR: " . $DBI::errstr,1);


my $sth = $db->prepare("SELECT worldid,skill from $tablename");

if ($sth->execute()) {
	my $row = undef;
	while( $row = $sth->fetchrow_hashref ) {
		$row->{skill} =~ s/\.\d*$//; # remove decimal
		print FOUT "$row->{worldid}, $row->{skill}\n";
	}
} else {
  die "MYSQL ERROR: " . $sth->errstr;
}

close FOUT;

exit 0;