

template<class HelperClass>
void BodCommand(edict_t* pPlayerEdict, CBaseEntity* pPlayer)
{
	if(MatchesCommand("bod")) {
		if(! HelperClass::IsAdmin(pPlayerEdict))
			RETURN_META(MRES_IGNORED);

		TeamBalance::update();
		g_balanceOnDeath = true;
		InitPlayerDeathStatus();

		if(TeamBalance::get() == NO_TEAM) {
			HelperClass::MessageA(pPlayer,"Teams are balanced!");
			g_balanceOnDeath = false;
		} else if(TeamBalance::get() == MARINE_TEAM) {
			HelperClass::MessageA(pPlayer, "Marine team is unbalanced");
			NSASayAll("Teams unbalanced - next Marine to die goes to the ReadyRoom\n", HUD_PRINTTALK);
		} else if(TeamBalance::get() == ALIEN_TEAM) {
			HelperClass::MessageA(pPlayer,  "Alien team is unbalanced");
			NSASayAll("Teams unbalanced - next Alien to die goes to the ReadyRoom\n", HUD_PRINTTALK);
		}

		RETURN_META(MRES_SUPERCEDE); // don't print the command
	} else if (MatchesCommand("showlast") || MatchesCommand("sl")) {
		char buf [512];

		PlayerInfo lastMarine = GetLastMarine();
		PlayerInfo lastAlien = GetLastAlien();

		if(lastMarine.joinTime == 0)
			lastMarine.joinTime = gpGlobals->time;

		if(lastAlien.joinTime == 0)
			lastAlien.joinTime = gpGlobals->time;

		int marineMin, marineSec, alienMin, alienSec;
		marineMin = (int)(gpGlobals->time-lastMarine.joinTime)/60;
		marineSec = (int)(gpGlobals->time-lastMarine.joinTime)%60;
		alienMin = (int)(gpGlobals->time-lastAlien.joinTime)/60;
		alienSec = (int)(gpGlobals->time-lastAlien.joinTime)%60;
		SNPRINTF(buf, 511, "last marine: %s (on for %d:%02d)\nlast alien: %s (on for %d:%02d)", 
			lastMarine.name.c_str(),
			marineMin, marineSec,
			lastAlien.name.c_str(),
			alienMin, alienSec);
		buf[511] = '\0';
		HelperClass::MessageA(pPlayer, buf);
		RETURN_META(MRES_SUPERCEDE);
	} else if(MatchesCommand("movelast") || MatchesCommand("ml")) {

		if(! HelperClass::IsAdmin(pPlayerEdict))
			RETURN_META(MRES_IGNORED);

		TeamBalance::update();

		int unbalancedTeam = TeamBalance::get();

		if(unbalancedTeam == NO_TEAM) {
			HelperClass::MessageA(pPlayer,"Teams are balanced!");
		}
		else if(unbalancedTeam == MARINE_TEAM) {
			if(GetLastMarine().name == "") {
				HelperClass::MessageA(pPlayer, "Last marine player unknown - can't balance");
			} else {
				CBaseEntity* pBootedMarine = UTIL_PlayerByName(GetLastMarine().name.c_str());

				if(pBootedMarine) {
					char buf[300];
					SNPRINTF(buf, 299, "Teams unbalanced - last player that joined (%s) is now in the ready room\n",GetLastMarine().name.c_str());
					buf[299] = '\0';

					NSASayAll(buf, HUD_PRINTTALK);
					CLIENT_COMMAND(pBootedMarine->edict(), "readyroom\n");
				} else {
					HelperClass::MessageA(pPlayer,"Doh, can't boot the last marine player\n");
				}
			}	
		} else if(unbalancedTeam == ALIEN_TEAM) {
			if(GetLastAlien().name == "") {
				HelperClass::MessageA(pPlayer, "Last alien player unknown - can't balance");
			} else {
				CBaseEntity* pBootedAlien = UTIL_PlayerByName(GetLastAlien().name.c_str());
				if(pBootedAlien) {
					char buf[300];
					SNPRINTF(buf, 299, "Teams unbalanced - last player that joined (%s) is now in the ready room\n",GetLastAlien().name.c_str());
					buf[299] = '\0';
					NSASayAll(buf, HUD_PRINTTALK);
					CLIENT_COMMAND(pBootedAlien->edict(), "readyroom\n");
				} else {
					HelperClass::MessageA(pPlayer,"Doh, can't boot the last alien player\n");
				}
			}	
		}
		RETURN_META(MRES_SUPERCEDE);
	} else if(MatchesCommand("rrr")) { // "ReadyRoomRandom"
		if(! HelperClass::IsAdmin(pPlayerEdict))
			RETURN_META(MRES_IGNORED);

		NSASayAll("Ready Room is being cleaned out\n", HUD_PRINTTALK);

		CBaseEntity* movedPlayer;
		char buf[300];
		for (int iIndex = 1; iIndex <= gpGlobals->maxClients; iIndex++)
		{
			movedPlayer = UTIL_PlayerByIndex(iIndex);
			if(movedPlayer != NULL)
			{
				if(movedPlayer->pev->team == READYROOM_TEAM && strcmp(STRING(movedPlayer->pev->netname),"") != 0) {
					SNPRINTF(buf, 299, "sending %s to a random team\n", STRING(movedPlayer->pev->netname));
					buf[299] = '\0';
					NSASayAll(buf, HUD_PRINTTALK);
					CLIENT_COMMAND(movedPlayer->edict(), "autoassign\n");	
				}
			}
		}
		RETURN_META(MRES_SUPERCEDE);

	} else if(MatchesCommand("eventeams") || MatchesCommand("eventeam")) { 
		// sends people from ready room to a team to make them as balanced as possible

		if(! HelperClass::IsAdmin(pPlayerEdict))
			RETURN_META(MRES_IGNORED);


		PlayerValuesConfig& playerValues = PlayerValuesConfig::getInst();

		// check to see if player values are loaded
		if(playerValues.isLoaded()) {

			// if so, generate a list of player names and teams
			playerlist players;
			int rrCount = 0; // # ppl in ready room

			for (int playerIndex = 1; playerIndex <= gpGlobals->maxClients; playerIndex++)
			{
				edict_t *pPlayerE = INDEXENT( playerIndex );
				if ( pPlayerE && 
					!pPlayerE->free &&
					strcmp(UTIL_GetPlayerName(pPlayerE), "") != 0 )
				{
					players.push_back(	PlayerInfo(	UTIL_GetPlayerName(pPlayerE), 
						playerValues.getValue(SteamID(GETPLAYERAUTHID(pPlayerE))), 
						(Team)UTIL_GetPlayerTeam(pPlayerE)
						));

					if(players.back().team == READYROOM_TEAM)
						rrCount++;
				}
			}

			//NSASayAll("playernames create ok\n", HUD_PRINTTALK);

			// bail if no one is in the ready room
			if(rrCount < 1) {
				RETURN_META(MRES_SUPERCEDE);
			}

			// generate the two team listings
			TeamComputer evenTeams(players, playerValues);

			//NSASayAll("eventeams cons ok\n", HUD_PRINTTALK);

			// grab the results
			strvec team1Players, team2Players;
			evenTeams.getEvenTeams(team1Players, team2Players);

			//NSASayAll("calc eventeams ok\n", HUD_PRINTTALK);

			// assign all players to new teams 
			// (have to do both teams simultaneously 'cause of mp_limitteams)

			// ! what happens if someone is already on a Team and the join Team command is sent?

			strvec::iterator i1 = team1Players.begin();
			strvec::iterator i2 = team2Players.begin(); 

			while(i1 != team1Players.end() || i2 != team2Players.end() ) {
				if(i1 != team1Players.end()) {
					CBaseEntity* pPlayer_ = UTIL_PlayerByName(i1->c_str());
					if(pPlayer_ != NULL) {
						CLIENT_COMMAND(pPlayer_->edict(), "jointeamone\n");
					}
					i1++;
				}
				if(i2 != team2Players.end()) {
					CBaseEntity* pPlayer_ = UTIL_PlayerByName(i2->c_str());
					if(pPlayer_ != NULL) {
						CLIENT_COMMAND(pPlayer_->edict(), "jointeamtwo\n");
					}
					i2++;
				}
			}

			NSASayAll("New teams assigned.  Say /stv for more info\n", HUD_PRINTTALK);
		} else {
			UTIL_LogPrintf("bod warning: player_values.txt file not loaded\n");
			HelperClass::MessageA(pPlayer, "Sorry, player values not loaded\n");
		}
		RETURN_META(MRES_SUPERCEDE);
	} else if(MatchesCommand("stv")) {  // "show team value"

		PlayerValuesConfig& playerValues = PlayerValuesConfig::getInst();

		if(playerValues.isLoaded()) {

			// if so, generate a vector of player names for each team
			playervec team1Players, team2Players;

			for (int playerIndex = 1; playerIndex <= gpGlobals->maxClients; playerIndex++)
			{
				edict_t *pPlayerE = INDEXENT( playerIndex );
				if ( pPlayerE && 
					!pPlayerE->free &&
					strcmp(UTIL_GetPlayerName(pPlayerE), "") != 0 )
				{
					if(pPlayerE->v.team == MARINE_TEAM) {
						team1Players.push_back(
							PlayerInfo(UTIL_GetPlayerName(pPlayerE), 
							playerValues.getValue(SteamID(GETPLAYERAUTHID(pPlayerE))), MARINE_TEAM)
							);
					} else if(pPlayerE->v.team == ALIEN_TEAM) {
						team2Players.push_back(
							PlayerInfo(UTIL_GetPlayerName(pPlayerE), 
							playerValues.getValue(SteamID(GETPLAYERAUTHID(pPlayerE))), ALIEN_TEAM)
							);
					}
				}
			}

			string tvs = TeamComputer::printTeams(team1Players, team2Players);
			HelperClass::MessageB(pPlayer,tvs.c_str());

		} else {
			UTIL_LogPrintf("bod warning: player values file not loaded\n");
			HelperClass::MessageA(pPlayer, "Sorry, player values not loaded\n");
		}
		RETURN_META(MRES_SUPERCEDE);
	} else if(MatchesCommand("bod_help")) {  // help!
		string helpMsg =	"\"Balance On Death\" (bod) commands\n"
			"\n"
			"To use: enter command at console or say /command\n"
			"* = admin only command\n"
			"\n"
			"stv - shows team values based on stats\n"
			"showlast or sl - show last player to join each team\n"
			"* bod - moves next player to die to even teams\n"
			"* movelast or ml - moves last player on the unbalanced team\n"
			"* rrr - randoms everyone in the readyroom\n"
			"* eventeams - assigns even teams based on stats\n";

		HelperClass::MessageB(pPlayer,helpMsg.c_str());

		RETURN_META(MRES_SUPERCEDE);
	}

	/* This command just seemed a bit too nasty.  There's always the "restart" command
	that does basically the same thing.
	else if(MatchesCommand("rr")) { // "ReadyRoom"
	if(! HelperClass::IsAdmin(pPlayerEdict))
	RETURN_META(MRES_IGNORED);

	NSASayAll("Moving everyone back to the Ready Room\n", HUD_PRINTTALK);

	CBaseEntity* pPlayer_;
	for (int iIndex = 1; iIndex <= gpGlobals->maxClients; iIndex++)
	{
	pPlayer_ = UTIL_PlayerByIndex(iIndex);
	if(pPlayer_ != NULL)
	{
	if(pPlayer_->pev->team != READYROOM_TEAM) {
	CLIENT_COMMAND(pPlayer_->edict(), "readyroom\n");	
	}
	}
	}
	RETURN_META(MRES_SUPERCEDE);
	} */

	RETURN_META(MRES_IGNORED);
}
