#ifndef PLAYER_INFO_H_
#define PLAYER_INFO_H_

#include <list>
#include <vector>
#include <string>
using namespace std;

#include "bod_defines.h"
#include "SteamID.h"


struct PlayerInfo
{
	PlayerInfo() : team(NO_TEAM),  joinTime(0.0)
	{ 
	}

	PlayerInfo(const string& n, const int& s, Team t = NO_TEAM)
		: name(n), skill(s), team(t), joinTime(0.0)
	{
	}

	PlayerInfo(const PlayerInfo& pti) { *this = pti; }


	PlayerInfo& operator=(const PlayerInfo& pji) {
		name =  pji.name;
		skill = pji.skill;
		team = pji.team;
		joinTime = pji.joinTime;
		return *this;
	}

	bool operator==(const PlayerInfo& pi)
	{
		return name == pi.name;
	}

	string name;
	int skill;
	Team team;
	float joinTime;
};

bool operator==(const string& lhs, const PlayerInfo& rhs);
bool operator==(const PlayerInfo& lhs, const string& rhs);


typedef list<PlayerInfo> playerlist;
typedef vector<PlayerInfo> playervec;

#endif
