
#include <string>
#include <map>
#include <fstream>
using namespace std;


#include "PlayerValuesConfig.h"


void readline(ifstream& fin, string& str)
{
	char buf[512];

	fin.getline(buf, 512,'\n');
	str = buf;
}

PlayerValuesConfig& PlayerValuesConfig::getInst()
{
	static PlayerValuesConfig inst;
	return inst;
}


bool PlayerValuesConfig::loadPlayerValues(const string& filename)
{
	ifstream fin(filename.c_str());

	if(fin.fail()) {
		return false;
	}

	if(isLoaded()) {
		playerValues.clear();
		avgVal=0;
	}

	int valSum=0;
	string line;
	readline(fin,line);
	while(! fin.eof()) {
		int last_comma = (int)line.find_last_of(',');

		// player steamid is in front of the comma, player value is after it
		string steamid = line.substr(0, last_comma);
		int value = atoi(line.substr(last_comma+1).c_str());

		playerValues[SteamID(steamid)] = value;
		// cout << "player: " << name << " = " << playerValues[name] << endl;
		valSum += value;

		readline(fin,line);
	}

	// if processing the file didn't actually do anything, bail
	if(valSum == 0) {
		playerValues.clear();
		avgVal=0;
		return false;
	}

	avgVal = static_cast<int>(valSum / playerValues.size());

	return true;
}