#ifndef PLAYER_VALUES_CONFIG_H_
#define PLAYER_VALUES_CONFIG_H_


#include <map>
#include <string>
using namespace std;

#include <time.h>

#include "SteamID.h"

class TeamComputer;

#define DUMMY_PLAYER_NAME "{24114F62-940A-4c20-A325-BB923197C0CE}"

//
// valid range of values - all positve integers
//
class PlayerValuesConfig {
public:
	static PlayerValuesConfig& getInst();

	bool loadConfig(const string& filename)
	{ 
		loadOK = loadPlayerValues(filename);
		if(loadOK) {
			time_t seconds;
			time(&seconds);
			srand((unsigned)seconds);
		}
		return loadOK;
	}

	bool isLoaded() const { return loadOK; }
	int getValue(const SteamID& steamid) const
	{ 
		map<SteamID,int>::const_iterator i = playerValues.find(steamid);
		if(i == playerValues.end()) { // if not found, make something up from 90% to 100% of avg value
			int newval = static_cast<int>(avgVal * ( 1.00 - ( rand() % 10 ) * .01));
			playerValues[steamid] = newval;
			return newval;
		} else {
			return (*i).second;
		}
	}
	void addValue(const SteamID& steamid, const int& val) { playerValues[steamid] = val; }

	friend class TeamComputer;

private:
	PlayerValuesConfig(const PlayerValuesConfig&) { ; } // no copying
	PlayerValuesConfig() : loadOK(false) { } // only getInst() can created
	bool loadPlayerValues(const string& filename);

	bool loadOK;
	int avgVal;
	mutable map<SteamID, int> playerValues;
};

#endif