#ifndef STEAMID_H_
#define STEAMID_H_

#include <string>
using std::string;

// simple SteamID class
//
// I needed a distinct type to prevent player name and SteamIDs from being mixed
struct SteamID
{
	SteamID() {}
	SteamID(const SteamID& sid)
		: val(sid.val)
	{
	}

	explicit SteamID(const string& str) 
		:  val(str) 
	{
	}

	const SteamID& operator=(const SteamID& rhs)
	{
		val = rhs.val;
		return *this;
	}

	string val;
};

// overload operator < to allow use in a map
bool operator<(const SteamID& lhs, const SteamID& rhs);


#endif