#ifndef TEAM_COMPUTER_H_
#define TEAM_COMPUTER_H_

#include <map>
#include <list>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>

#include <assert.h>

using namespace std;

#include "PlayerInfo.h"

typedef vector<string> strvec;

#include "PlayerValuesConfig.h"
#include "TeamComputerSolution.h"



class TeamComputer {
public:
	TeamComputer(const playerlist& ps, const PlayerValuesConfig& pvc) 
		: players(ps), playerValues(pvc), searchCount(0)
	{ 
		numPlayers = (int)players.size();
	}

	void getEvenTeams( strvec& team1Players, strvec& team2Players);
	static string printTeams(playervec team1Names, playervec team2Names); // args not const ref 'cause we sort'em

private:
	void doOptimalTeamSearch(Solution current, Solution& bestSoFar, bool& done);

	const PlayerValuesConfig& playerValues;
	const playerlist& players;
	int numPlayers;

	TeamInfo team1, team2; // used to save results of a search

	int searchCount;
};






#endif