#ifndef BOD_H_
#define BOD_H_

#include <meta_api.h>
#include "bod_defines.h"
#include "PlayerInfo.h"
#include "TeamBalance.h"


/*****************************************************************
 *
 * Global Variables
 *
 *****************************************************************/

// set in h_Export.cpp
extern enginefuncs_t g_engfuncs;
extern globalvars_t  *gpGlobals;

// balance warning
extern float g_imbalanceTime; // when did last imbalance occurr
extern float g_lastNoticeTime; // when was last notice sent
extern bool g_balanceNoticePending; // true if balance notice needs to be sent

extern bool g_balanceOnDeath; // should next death cause someone to be sent to the RR?

extern Team g_assignExtraPlayer; // makes a team appear to have 1 extra player than they really do


// set in engine MessageBegin when round starts.  It's 0 until a valid round start happens
// NOT NEEDED -> extern float g_roundStartTime;





/*****************************************************************
*
* Functions
*
*****************************************************************/


///
/// UTIL Funcs
///
extern void TeamHudMessage(Team team, const hudtextparms_t &textparms, const char *pMessage);
extern void UTIL_HudMessage(CBaseEntity *pEntity, const hudtextparms_t &textparms, const char *pMessage);
extern void UTIL_HudMessageA(CBaseEntity *pEntity, const char *pMessage);
extern void UTIL_HudMessageB(CBaseEntity *pEntity, const char *pMessage);
extern int UTIL_GetTeamCount(Team team);
extern bool UTIL_IsAdmin(edict_t *pEntity);
extern CBaseEntity* UTIL_PlayerByName(const char*);
extern const char* UTIL_GetPlayerName(edict_t*);
extern Team UTIL_GetPlayerTeam(edict_t*);

// returns which team has too many players, or NO_TEAM if they're balanced
extern int UTIL_CheckTeamBalance();

// sends message to all players who are admins
extern void UTIL_SendAdminsMessage(const char*);

extern CBaseEntity *GetLastPlayerOfTeam( Team team );
extern void NSASayAll(const char *pText, int msg_type);

///
/// bod funcs
///

// called from StartFrame, watches for deaths if we need to do a bod
void TrackDeaths();


// returns the last marine, as much as is possible to find
PlayerInfo GetLastMarine();

// returns the last alien, as much as is possible to find
PlayerInfo GetLastAlien();

// sets all member of PlayerAliveStatus array to their appropriate value
void InitPlayerDeathStatus();

// does initialization stuff
void bod_init();

// returns true if the current CMD_ARGs match either "command" or "say /command" or "sayteam /command"
bool MatchesCommand(const char*);

// keeps track of which players are on which teams
void TrackPlayerTeam(edict_t*);

#endif
