#ifndef BOD_DEFINES_H
#define BOD_DEFINES_H

/*****************************************************************
*
* Defines
*
*****************************************************************/


// UPDATE THE DLL RESOURCE VERSION!!
#define BOD_VERSION "1.01e"
/* remeber to update dll res version too! */ 

enum Team {
	ANY_TEAM=-2,
	NO_TEAM=-1,
	READYROOM_TEAM=0,
	MARINE_TEAM=1,
	ALIEN_TEAM=2
};

inline Team intToTeam(int i)
{ 
	return (i >= ANY_TEAM && i <= ALIEN_TEAM) ? static_cast<Team>(i) : NO_TEAM;
}


// difference in the size of teams that's considered unbalanced.  should be 2 more or
#define UNBALANCED_PLAYER_DIFFERENCE 2

// max length of a player's name (or at least my guess?)
#define MAX_PLAYER_NAME 256

// max players to track for determining who was the last to join the team
#define MAX_PLAYERS_TO_TRACK 8

// number of floating point seconds to wait after imbalance to send message to admins
#define IMBALANCE_NOTICE_DELAY 15.0

// minimum number of floating point seconds in between imbalance notices
#define MIN_IMBALANCE_NOTICE_REPEAT 60.0

#define ABS(x) (((x) < 0) ? (-(x)) : (x))

#ifdef __linux__

#define SNPRINTF snprintf
#define STRICMP strcasecmp

#ifndef __TIMESTAMP__
#define __TIMESTAMP__ __DATE__
#endif

// here come the windows defines
#else

#define SNPRINTF _snprintf
#define STRICMP stricmp

#endif

#endif
