// From SDK dlls/h_export.cpp:

/***
*
*	Copyright (c) 1999, 2000 Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/
/*

===== h_export.cpp ========================================================

  Entity classes exported by Halflife.

*/


#include <extdll.h>
#include <string.h> //to prevent linux errors while processing meta_api.h
#include <meta_api.h>
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work
#include <cbase.h>
#include <player.h>

#include <h_export.h>

#include "bod.h"
#include "BodCommand.h"

// From SDK dlls/h_export.cpp:

//! Holds engine functionality callbacks
enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;

// "aliens" or "marines" - specifies which team should be handicapped and 
//                         allow the other team to have an extra member
cvar_t mm_bod_version = {"mm_bod_version", BOD_VERSION,	FCVAR_SERVER , 0, NULL};
cvar_t bod_handicapteam = {"bod_handicapteam", "none", FCVAR_PROTECTED, 0, 0};
cvar_t bod_playervaluesfile = {"bod_playervaluesfile", "player_values.txt", FCVAR_PROTECTED, 0, 0};

void ServerCommand()
{
	// NOTE: RETURN_META() macros are used here, but they don't seem to hurt anyone...
	BodCommand<ServerCommandHelper>(NULL, NULL);
}


// Receive engine function table from engine.
// This appears to be the _first_ DLL routine called by the engine, so we
// do some setup operations here.
void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;

	CVAR_REGISTER(&mm_bod_version);
	CVAR_REGISTER(&bod_handicapteam);
	CVAR_REGISTER(&bod_playervaluesfile);

	REG_SVR_COMMAND("bod", ServerCommand);
	REG_SVR_COMMAND("bod_help", ServerCommand);
	REG_SVR_COMMAND("sl", ServerCommand);
	REG_SVR_COMMAND("showlast", ServerCommand);
	REG_SVR_COMMAND("ml", ServerCommand);
	REG_SVR_COMMAND("movelast", ServerCommand);
	REG_SVR_COMMAND("rrr", ServerCommand);
	REG_SVR_COMMAND("stv", ServerCommand);
	REG_SVR_COMMAND("eventeam", ServerCommand);
	REG_SVR_COMMAND("eventeams", ServerCommand);

}
